// FORMWHIZ Version 1.0
// Copyright (c) 1999 Ziff-Davis, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, September 21, 1999.
// Programmer: Patrick Philippot

// DefaultsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FWconf.h"
#include "..\FormWhizKeys.h"
#include "DefaultsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
											
const PTCHAR szDefaultsFile	= _T("fwdefs.txt");
											
/////////////////////////////////////////////////////////////////////////////
// CDefaultsDlg dialog


CDefaultsDlg::CDefaultsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDefaultsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDefaultsDlg)
	//}}AFX_DATA_INIT
}

void CDefaultsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDefaultsDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDefaultsDlg, CDialog)
	//{{AFX_MSG_MAP(CDefaultsDlg)
	ON_LBN_SELCHANGE(IDC_ENTRIES, OnSelChangeEntries)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDefaultsDlg message handlers

BOOL CDefaultsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_listDefaults.SubclassDlgItem(IDC_ENTRIES, this);

	TCHAR	szFilename[MAX_PATH];
	
	// Get the application path and concatenate with defaults filename
	::GetModuleFileName(NULL, szFilename, MAX_PATH);
	*(_tcsrchr(szFilename, (TCHAR) '\\') + 1) = (TCHAR) '\0';
	_tcscat(szFilename, szDefaultsFile);

	CStdioFile txt;
	
	if (txt.Open(szFilename, CFile::modeRead))
	{
		CString sLine;
								 
		// Get each line						 
		while (txt.ReadString(sLine))
		{
			if (!sLine.IsEmpty())
			{			
				// Get first token (before =)
				int nPos = sLine.Find((TCHAR) '=');

				if (nPos != -1)
				{							 
					// Add it to listbox
					int nItemIndex = m_listDefaults.AddString(sLine.Left(nPos));
					// Associate the remaining string with this item
					PTCHAR pTokens = new TCHAR[sLine.GetLength() + sizeof(TCHAR)];
					_tcscpy(pTokens, sLine.Mid(nPos+1));
					m_listDefaults.SetItemData(nItemIndex, (DWORD) pTokens);
				}
			}
		}
	}
	else	// File doesn't exist
	{	
		CString sCaption, sText;
		
		sCaption.LoadString(IDS_NODEFSCAPTION);
		sText.LoadString(IDS_NODEFSTEXT);
		MessageBox(sText, sCaption, MB_OK | MB_ICONEXCLAMATION);	
		EndDialog(IDCANCEL);
	}
	
	return TRUE;
}

void CDefaultsDlg::CleanUpList()
// Delete associated strings before closing
// This to prevent from creating memory leaks.
{
	int nCount = m_listDefaults.GetCount();

	for (int i = 0; i < nCount; i++)
		delete (PTCHAR) m_listDefaults.GetItemData(i);
}

void CDefaultsDlg::OnSelChangeEntries() 
{					 
	int nIndex = m_listDefaults.GetCurSel();

	// Return associated string
	if (nIndex != LB_ERR)
		m_sDefaults = (LPSTR) m_listDefaults.GetItemData(nIndex);
}

void CDefaultsDlg::OnDestroy() 
{
	CleanUpList();
	CDialog::OnDestroy();
}
