// FORMWHIZ Version 1.0
// Copyright (c) 1999 Ziff-Davis, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, September 21, 1999.
// Programmer: Patrick Philippot

// FWConf.cpp : Defines the class behaviors for the application.

#include "stdafx.h"
#include "FWConf.h"
#include "FWConfDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const PTCHAR szMutex = _T("FWConf_Mutex");

#pragma data_seg( "FWConf_Shared" )
HWND	g_hMainWindow = NULL;
#pragma data_seg()

/////////////////////////////////////////////////////////////////////////////
// CFWConfApp

BEGIN_MESSAGE_MAP(CFWConfApp, CWinApp)
	//{{AFX_MSG_MAP(CFWConfApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFWConfApp construction

CFWConfApp::CFWConfApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFWConfApp object

CFWConfApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFWConfApp initialization

BOOL CFWConfApp::InitInstance()
{
	// AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// A mutex is used to prevent multiple instances of FWConf
	if ((m_hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, szMutex)) != NULL)
	{
		// FWConf already running
		CloseHandle(m_hMutex);
		m_hMutex = NULL;
		::SetForegroundWindow(g_hMainWindow);
		return(FALSE);
	}
	else
		m_hMutex = CreateMutex(NULL, TRUE, szMutex);

	CFWConfDlg dlg(IDS_PROPSHEETCAPTION);

	m_pMainWnd = &dlg;
	dlg.DoModal();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CFWConfApp::ExitInstance() 
{
	if (m_hMutex != NULL)
		CloseHandle(m_hMutex);

	return CWinApp::ExitInstance();
}

void CFWConfApp::SetWindowHandle(HWND hWnd)
{
	g_hMainWindow = hWnd;
}