// FORMWHIZ Version 1.0
// Copyright (c) 1999 Ziff-Davis, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, September 21, 1999.
// Programmer: Patrick Philippot

// FWConfDlg.cpp : implementation file

#include "stdafx.h"
#include "FWConf.h"
#include "FWConfDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFWConfDlg

IMPLEMENT_DYNAMIC(CFWConfDlg, CPropertySheet)

CFWConfDlg::CFWConfDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_AssocPage);
	AddPage(&m_KeyPage);
	AddPage(&m_URLPage);
}

CFWConfDlg::CFWConfDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
}

CFWConfDlg::~CFWConfDlg()
{
}


BEGIN_MESSAGE_MAP(CFWConfDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CFWConfDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_COMMAND(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFWConfDlg message handlers

BOOL CFWConfDlg::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	
	// Load the app icons
	SetIcon( AfxGetApp()->LoadIcon( IDI_FWCONF_SMALL ), FALSE );
	SetIcon( AfxGetApp()->LoadIcon( IDI_FWCONF ), TRUE );
	
	// Add the minimize button to the window
	::SetWindowLong( m_hWnd, GWL_STYLE, GetStyle() | WS_MINIMIZEBOX );
		
	// Add the minimize and About commands to the system menu
	GetSystemMenu( FALSE )->InsertMenu(-1, MF_BYPOSITION | MF_STRING, SC_ICON, "Minimize");
	GetSystemMenu( FALSE )->InsertMenu(-1, MF_SEPARATOR);

	CString sAbout;
	sAbout.LoadString(IDS_ABOUTBOX);
	GetSystemMenu( FALSE )->InsertMenu(-1, MF_BYPOSITION | MF_STRING, SC_ABOUT, sAbout);
	
	// Pass window handle to application
	((CFWConfApp*) AfxGetApp())->SetWindowHandle(m_hWnd);

	// Activate the new sysmenu
	DrawMenuBar();

	// Now adds a non-standard About button
	// Firtst move standard buttons to the left
	CRect rectOK, rectCancel, rectCurrent, rectAbout;

	GetDlgItem(IDOK)->GetWindowRect(rectOK);
	GetDlgItem(IDCANCEL)->GetWindowRect(rectCancel);

	int nStep = rectOK.left - rectCancel.left;

	int ids[] = {IDOK, IDCANCEL, ID_APPLY_NOW, IDHELP };

	for(int i = 0; i < sizeof(ids) / sizeof(ids[0]); i++)
	{
		GetDlgItem(ids[i])->GetWindowRect(rectCurrent);

		if (ids[i] == IDHELP)
		{
			rectAbout = rectCurrent;
			ScreenToClient(&rectAbout);
		}
		rectCurrent.left += nStep;
		rectCurrent.right += nStep;
		ScreenToClient(&rectCurrent);
		GetDlgItem(ids[i])->MoveWindow(rectCurrent);
	}

	// Next create About button
	m_AboutButton.Create ("&About", 
						  WS_CHILD | WS_VISIBLE | WS_TABSTOP,
                          rectAbout,
                          this, 
						  IDC_ABOUT);
	// Set same font as stndard buttons
	GetDlgItem(IDC_ABOUT)->SetFont(GetDlgItem(IDHELP)->GetFont(), TRUE);

	return bResult;
}

void CFWConfDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if (nID == SC_ABOUT)
		OnAbout();
	
	CPropertySheet::OnSysCommand(nID, lParam);
}


void CFWConfDlg::OnDestroy() 
{
	AfxGetApp()->WinHelp(0L, HELP_QUIT);

	CPropertySheet::OnDestroy();
}

void CFWConfDlg::OnAbout()
{
	CAboutDlg dlg;

	dlg.DoModal();
}

BOOL CFWConfDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// This is to differenciate the processing of the F1
	// key from a click on the Help button.
	if ((LOWORD(wParam) == IDHELP) && (LOWORD(wParam) != 1))
	{
		AfxGetApp()->WinHelp(0, HELP_FINDER);
		return TRUE;
	}
	else
		return CPropertySheet::OnCommand(wParam, lParam);
}
