// FORMWHIZ Version 1.0
// Copyright (c) 1999 Ziff-Davis, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, September 21, 1999.
// Programmer: Patrick Philippot

#if !defined(AFX_PROPPAGES_H__015D74B6_DA12_11D2_8DDE_00A0249EABF4__INCLUDED_)
#define AFX_PROPPAGES_H__015D74B6_DA12_11D2_8DDE_00A0249EABF4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropPages.h : header file
//

#include "fwhotkeyctrl.h"

/////////////////////////////////////////////////////////////////////////////
// CAssocPage dialog

#define WM_EDITLOSTFOCUS 	(WM_USER + 100)

class CAssocPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CAssocPage)

// Construction
public:
	CAssocPage();
	~CAssocPage();

// Dialog Data
	//{{AFX_DATA(CAssocPage)
	enum { IDD = IDD_PROPPAGE_ASSOC };
	BOOL	m_bForceFillIn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CAssocPage)
	public:
	virtual BOOL OnApply();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CAssocPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelChangeKeywords();
	afx_msg void OnDestroy();
	afx_msg void OnRemoveAssoc();
	afx_msg void OnUp();
	afx_msg void OnDown();
	afx_msg void OnNewAssoc();
	afx_msg void OnChangeForceFillin();
	afx_msg LONG OnEditLostFocus(UINT id, LONG);
	afx_msg void OnChangeTokens();
	afx_msg void OnEmpty();
	afx_msg void OnDefaults();
	afx_msg void NotifyKillFocus();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void InitControls();
	void DisplayKeyword(int nIndex);
	void CleanUpList();
	void SetUpDownButtons();
	void UpdateAssoc(int nIndex);


// Attributes
public:
	CListBox		m_listKeywords;
	CEdit			m_edKeyword;
	CEdit			m_edTokens;
	CToolTipCtrl*	m_pToolTip;
};

/////////////////////////////////////////////////////////////////////////////
// CKeyPage dialog

class CKeyPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CKeyPage)

// Construction
public:
	CKeyPage();
	~CKeyPage();

// Dialog Data
	//{{AFX_DATA(CKeyPage)
	enum { IDD = IDD_PROPPAGE_KEYS };
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CKeyPage)
	public:
	virtual BOOL OnApply();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CKeyPage)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void InitControls();

// Attributes
public:
	
	CFWHotKeyCtrl	m_keySerialize;
	CFWHotKeyCtrl	m_keyDelete;
	CFWHotKeyCtrl	m_keyConfig;
	CFWHotKeyCtrl	m_keyToggle;
	CToolTipCtrl*	m_pToolTip;
};
/////////////////////////////////////////////////////////////////////////////
// CURLPage dialog

class CURLPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CURLPage)

// Construction
public:
	CURLPage();
	~CURLPage();

// Dialog Data
	//{{AFX_DATA(CURLPage)
	enum { IDD = IDD_PROPPAGE_URLS };
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CURLPage)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CURLPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeUrls();
	afx_msg void OnRemove();
	afx_msg void OnDestroy();
	afx_msg void InitControls();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void DisplayURL(int nIndex);
	void CleanUpList();

// Attributes
public:

	CListBox		m_listURLs;
	CStatic			m_stTarget;
	CToolTipCtrl*	m_pToolTip;

};
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPPAGES_H__015D74B6_DA12_11D2_8DDE_00A0249EABF4__INCLUDED_)
