// FORMWHIZ Version 1.0
// Copyright (c) 1999 Ziff-Davis, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, September 21, 1999.
// Programmer: Patrick Philippot

// FormWhizObj.h : Declaration of the CFormWhizObj

#ifndef __FormWhizOBJ_H_
#define __FormWhizOBJ_H_

#include "resource.h"       // main symbols
#include <ExDisp.h>
#include <msHtml.h>

#define	MAX_DOCUMENTS	50

/////////////////////////////////////////////////////////////////////////////
// CFormWhizObj
class ATL_NO_VTABLE CFormWhizObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CFormWhizObj, &CLSID_FormWhizObj>,
	public IObjectWithSiteImpl<CFormWhizObj>,
	public IDispatchImpl<IFormWhizObj, &IID_IFormWhizObj, &LIBID_FormWhizLib>
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_FORMWHIZOBJ)
	DECLARE_NOT_AGGREGATABLE(CFormWhizObj)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFormWhizObj)
	COM_INTERFACE_ENTRY(IFormWhizObj)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectWithSite)
END_COM_MAP()

// IFormWhizObj
public:
	//
	// CFormWhizObj Methods
	//
	CFormWhizObj();
	~CFormWhizObj();

	//
	// IDispatch Methods
	//
	STDMETHOD(Invoke)(DISPID dispidMember,REFIID riid, LCID lcid, WORD wFlags,
						DISPPARAMS * pdispparams, VARIANT * pvarResult,
						EXCEPINFO * pexcepinfo, UINT * puArgErr);

	//
	// IOleObjectWithSite Methods
	//
	STDMETHOD(SetSite)(IUnknown *pUnkSite);

private:

	enum	errType {errWarning, errError, errInfo};

	DWORD	m_dwCookie;	// Connection Token - used for Advise and Unadvise
	HWND	m_hwndIE;	// handle to IE main window	
	CComQIPtr<IWebBrowser2, &IID_IWebBrowser2> m_spWebBrowser2;
	CComPtr<IHTMLDocument2> Documents[MAX_DOCUMENTS];
	UINT	m_nDocNum;
	BOOL	m_bHotkeysEnabled;
	BOOL	m_bDocComplete;
	HHOOK	m_hHook;	// Handle for the keyboard hook

	// Options

	enum	AdviseAction { Advise, Unadvise };   // What to do when managing the connection

	BOOL	ManageConnection(enum AdviseAction action);
	BOOL 	RetrieveURL(IHTMLDocument2* pHTML, LPSTR lpszURL, UINT nMaxLen);
	void	AddDocument(IHTMLDocument2* pDoc);
	void	RemoveDocument(IHTMLDocument2* pDoc);
	BOOL	DoFillIn(IHTMLDocument2* pIDoc = NULL );
	BOOL	TagMatch(_variant_t* vValue, CRegKey& regkey);
	BOOL	SerializeForms(BOOL bStoring, 
						   IHTMLDocument2* pIDoc = NULL, 
						   BOOL* pbFormNotEmpty = NULL, 
						   BOOL* pbPwdRecorded = NULL);
	void	DeleteFormFile();
	BOOL	WriteString(HANDLE hFile, LPCTSTR lpszString);
	BOOL	ReadString(HANDLE hFile, LPSTR lpszString, DWORD dwMaxLen);
	static	LRESULT CALLBACK IEKeyboardProc(int, WPARAM, LPARAM);	
	UINT	GetKeyState();
	BOOL 	KeyMatch(UINT nState, WPARAM wParam, DWORD dwKey);
	void	RunConfig();
	void	ToggleState();
	void	FormWhizError(int nTextId, errType e);
};

#endif //__FormWhizOBJ_H_
